package de.vanitasvitae.fasel.db.entity;

import com.j256.ormlite.field.DataType;
import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.table.DatabaseTable;
import lombok.Getter;
import lombok.Setter;

@DatabaseTable(tableName = "Avatars")
public class Avatar {

    public static final String AVATAR_ID = "avatarID";
    public static final String ENTITY = "entity";
    public static final String IMAGE = "image";
    public static final String HASH = "hash";

    @Getter
    @Setter
    @DatabaseField(generatedId = true, columnName = AVATAR_ID, dataType = DataType.LONG)
    private Long avatarID;

    @Getter
    @Setter
    @DatabaseField(foreign = true, columnName = ENTITY, unique = true)
    private XmppEntity entity;

    @Getter
    @Setter
    @DatabaseField(columnName = IMAGE, dataType = DataType.BYTE_ARRAY)
    private byte[] image;

    @Getter
    @Setter
    @DatabaseField(columnName = HASH, dataType = DataType.STRING)
    private String hash;

    public Avatar() {

    }
}
