package de.vanitasvitae.fasel.db.entity;

import com.j256.ormlite.field.DataType;
import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.table.DatabaseTable;
import de.vanitasvitae.fasel.db.dao.impl.XmppEntityDaoImpl;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;

@EqualsAndHashCode
@DatabaseTable(tableName = "entities", daoClass = XmppEntityDaoImpl.class)
public class XmppEntity {

    public static final String ENTITY_ID = "entityID";
    public static final String JID = "jid";

    public XmppEntity() {

    }

    public XmppEntity(String jid) {
        this.jid = jid;
    }

    @Getter
    @DatabaseField(generatedId = true, columnName = ENTITY_ID, dataType = DataType.LONG)
    private long entityID;

    @Getter
    @Setter
    @DatabaseField(columnName = JID, dataType = DataType.STRING)
    private String jid;

    @Override
    public String toString() {
        return "XmppEntity[" + entityID + ", " + jid + "]";
    }
}
